# angular_redux_dev_tools

[![Build Status](https://api.travis-ci.org/localhurst/angular_redux_dev_tools.svg?branch=master)](https://travis-ci.org/localhurst/angular_redux_dev_tools)

An AngularDart component you can use to show a [Redux](https://pub.dartlang.org/packages/redux) Time Travel UI. 

### Usage

Add imports for `DevToolsStore` and `ReduxDevToolsComponent`:
```dart
import 'package:angular_redux_dev_tools/redux_dev_tools_component.dart';
import 'package:redux_dev_tools/redux_dev_tools.dart';
```

- Add `ReduxDevToolsComponent` to your component's `directives`
- Create a `<redux-dev-tools>` element
- Bind a `DevToolsStore` to the `store` property
```dart
@Component(
  selector: 'my-example',
  template: '<redux-dev-tools [store]="store"></redux-dev-tools>',
  directives: const [ReduxDevToolsComponent],
)
class ExampleComponent {
    final DevToolsStore store = new DevToolsStore(exampleReducer);
}
```

Note: This Widget does not work with a normal [Redux](https://pub.dartlang.org/packages/redux) `Store`. It is meant to work with the [redux_dev_tools package](https://pub.dartlang.org/packages/redux_dev_tools), which provides a `DevToolsStore`. The `DevToolsStore` is a drop-in replacement for your Store during Development!

### Demo

Vanilla counter demo

![Vanilla counter demo video](https://raw.githubusercontent.com/localhurst/angular_redux_dev_tools/master/devtools.gif)

### Example

To launch the examples in your browser:

- Run `pub serve example` from this directory
- Open [http://localhost:8080](http://localhost:8080)

## Credits

All of this is inspired by the original [Redux Devtools](https://github.com/gaearon/redux-devtools).
and [Flutter Redux Devtools](https://github.com/brianegan/flutter_redux_dev_tools).
