// ignore_for_file: avoid_setters_without_getters
import 'package:angular/angular.dart';
import 'package:angular_components/material_button/material_button.dart';
import 'package:angular_components/material_icon/material_icon.dart';
import 'package:angular_components/model/ui/has_renderer.dart';
import 'package:redux_dev_tools/redux_dev_tools.dart';

import 'redux_dev_tools_component.dart';

/// Child component that displays state index and `toString()`.
@Component(
    selector: 'computed-state',
    template: '''
    <span class="state-index">[ {{index}} ]</span>
    <span class="state-to-string">{{computedState?.toString()}}</span>
  ''',
    styles: const [
      '.state-index { color: lightgrey; padding-right: 8px; }'
    ],
    directives: const [
      MaterialIconComponent,
      MaterialButtonComponent,
    ],
    providers: const [
      devToolsStoreProvider
    ])
class ComputedStateComponent implements RendersValue {
  final DevToolsStore _store;

  /// State object to display.
  Object computedState;

  /// Final field constructor.
  ComputedStateComponent(this._store);

  /// Find the index of the state.
  int get index => _store.devToolsState.computedStates.indexOf(computedState);

  @override
  set value(Object state) => computedState = state;
}
